/** Gestion des nombres complexes **/

typedef struct complex { double reel, imag; } complex;

#define kfft_complexmult(x, y, r) {\
r.reel = x.reel*y.reel - x.imag*y.imag;\
r.imag = x.reel*y.imag + x.imag*y.reel; }
 
#define kfft_complexplus(x, y, r) {\
r.reel = x.reel+y.reel;\
r.imag = x.imag+y.imag; }
 
#define kfft_complexmoins(x, y, r) {\
r.reel = x.reel-y.reel;\
r.imag = x.imag-y.imag; }

#define kfft_module(x) (sqrt(x.reel*x.reel + x.imag*x.imag))
#define phase(x)  (atan2(x.imag, x.reel))


/** Variables globales importantes **/

double *kfft_modules_reels;  /* amplitudes */
double *kfft_phases_reels;   /* phases */
complex *kfft_onde_complexe; /* signal de kfft_nbfreqs echantillons 
				ou spectre de kfft_nbfreqs frequences */


/** Prototypage **/

#ifdef __cplusplus
extern "C" {
int close (...);
#endif

extern void kfft_Init();
extern void kfft_Release();
extern void kfft_Analyse (KWAV_ECH *s);
extern void kfft_Synthese ();
extern void kfft_set_nbfreqs (int nbfreqs);
extern int  kfft_get_nbfreqs ();

#ifdef __cplusplus
}
#endif

